package com.tptj.demo.hg.db.access.provider;

import com.fanruan.api.log.LogKit;
import com.fr.json.JSONObject;
import com.fr.json.revise.EmbedJson;
import com.fr.stable.db.entity.converter.BaseConverter;

/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021-04-25
 **/
public class BeanConverter extends BaseConverter<DemoBean,String> {
    @Override
    public String convertToDatabaseColumn(DemoBean bean) {
        if( null == bean ){
            return "{}";
        }
        return JSONObject.mapFrom(bean).toString();
    }

    @Override
    public DemoBean convertToEntityAttribute(String val ) {
        try{
            return EmbedJson.MAPPER.readValue(val,DemoBean.class);
        }catch(Exception e){
            LogKit.error(e,"{} can not convert to DemoBean for {}",val,e.getMessage());
        }
        return new DemoBean();
    }
}
