package com.tptj.demo.hg.db.access.provider;

import com.fr.decision.webservice.Response;
import com.fr.decision.webservice.annotation.LoginStatusChecker;
import com.fr.third.springframework.stereotype.Controller;
import com.fr.third.springframework.web.bind.annotation.*;

/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021-04-25
 **/
@Controller("DBAccessDemoController")
@LoginStatusChecker(required = false)
@RequestMapping(value = "/db/demo")
public class DemoController {

    @RequestMapping( value = "/dm_entity", method = RequestMethod.POST )
    @ResponseBody
    public Response add( @RequestBody DataBean bean )throws Exception{
        DemoDbController.add(bean);
        return Response.ok( bean );
    }

    @RequestMapping( value = "/dm_entity/{entity}", method = RequestMethod.DELETE )
    @ResponseBody
    public Response delete( @PathVariable("entity") String entity )throws Exception{
        return Response.ok( DemoDbController.delete(entity) );
    }

    @RequestMapping( value = "/dm_entity", method = RequestMethod.PUT )
    @ResponseBody
    public Response update( @RequestBody DataBean bean )throws Exception{
        DemoDbController.update(bean);
        return Response.ok( bean );
    }

    @RequestMapping( value = "/dm_entity", method = RequestMethod.GET )
    @ResponseBody
    public Response like( @RequestParam(value = "key") String key )throws Exception{
        return Response.ok( DemoDbController.like(key) );
    }
}

