package com.tptj.demo.hg.db.access.provider;

import com.fr.stable.db.dao.BaseDAO;
import com.fr.stable.db.dao.DAOProvider;
import com.fr.stable.db.session.DAOSession;
import com.fr.stable.query.QueryFactory;
import com.fr.stable.query.condition.QueryCondition;
import com.fr.stable.query.restriction.RestrictionFactory;

import java.util.List;

/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021-04-25
 **/
public class DemoDao extends BaseDAO<DemoEntity> {

    public DemoDao(DAOSession session) {
        super(session);
    }

    @Override
    protected Class<DemoEntity> getEntityClass() {
        return DemoEntity.class;
    }

    public final static DAOProvider DAO = new DAOProvider() {
        @Override
        public Class getEntityClass() {
            return DemoEntity.class;
        }

        @Override
        public Class<? extends BaseDAO> getDAOClass() {
            return DemoDao.class;
        }
    };

    public List<DemoEntity> likeByKey( String key )throws Exception{
        QueryCondition condition = QueryFactory.create()
                .addRestriction(RestrictionFactory.like(DemoEntity.COLUMN_KEY, key));
        return find(condition);
    }

    public void add(DemoEntity entity) throws Exception {
        getSession().persist(entity);
    }

    public void update(DemoEntity entity) throws Exception {
        getSession().merge(entity);
    }

    public DemoEntity getById(String id) throws Exception {
        return getSession().getById(id, DemoEntity.class);
    }

    public void remove(String id) throws Exception {
        getSession().remove(QueryFactory.create()
                .addRestriction(RestrictionFactory.eq("id", id)),
                this.getEntityClass());
    }
}
