package com.tptj.demo.hg.db.access.provider;

import com.fr.stable.db.dao.BaseDAO;
import com.fr.stable.db.dao.DAOProvider;
import com.fr.stable.db.entity.BaseEntity;
import com.fr.stable.db.session.DAOSession;
import com.fr.stable.query.QueryFactory;
import com.fr.stable.query.condition.QueryCondition;
import com.fr.stable.query.restriction.RestrictionFactory;

import java.util.List;

/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021-04-25
 **/
public class LinkDao extends BaseDAO<LinkEntity> {
    public LinkDao(DAOSession session) {
        super(session);
    }

    @Override
    protected Class<LinkEntity> getEntityClass() {
        return LinkEntity.class;
    }

    public final static DAOProvider DAO = new DAOProvider() {
        @Override
        public Class getEntityClass() {
            return LinkEntity.class;
        }

        @Override
        public Class<? extends BaseDAO> getDAOClass() {
            return LinkDao.class;
        }
    };

    public void add( List<LinkEntity> list )throws Exception {
        for( LinkEntity item : list ){
            add(item);
        }
    }

    public void addOrUpdate( List<LinkEntity> list )throws Exception {
        for( LinkEntity item : list ){
            addOrUpdate(item);
        }
    }

    public List<LinkEntity> removeByKey( String key )throws Exception{
        QueryCondition condition = QueryFactory.create().addRestriction(RestrictionFactory.eq(LinkEntity.COLUMN_KEY, key));
        List<LinkEntity> list = find(condition);
        for( LinkEntity item : list ){
            remove( item.getId() );
        }
        return list;
    }

    public List<LinkEntity> getByKey( String key )throws Exception{
        QueryCondition condition = QueryFactory.create().addRestriction(RestrictionFactory.eq(LinkEntity.COLUMN_KEY, key));
        return find(condition);
    }

    public void add(LinkEntity entity) throws Exception {
        getSession().persist(entity);
    }

    public void update(LinkEntity entity) throws Exception {
        getSession().merge(entity);
    }

    public void addOrUpdate(LinkEntity entity) throws Exception {
        if (entity != null && this.getById(entity.getId()) != null) {
            update(entity);
        } else {
            add(entity);
        }
    }

    public LinkEntity getById(String id) throws Exception {
        return this.getSession().getById(id, LinkEntity.class);
    }

    public void remove(String id) throws Exception {
        this.getSession().remove(QueryFactory.create().addRestriction(RestrictionFactory.eq("id", id)), this.getEntityClass());
    }
}
